FUNCTION sw_mapread, projname, FILEPATH=filepath, QALL=qall, UALL=uall, VALL=vall, $
                    FITS=fits, DISTANCE=distance, Lambda=lambda, PIXSIZE=PixSize


;;Ex. result = ('name',fits='name',distance=100)
 
;; distance to be given in pc

;;
;; read sebastians files into an idl array and make a fits-file
;; suitable for simvlti


;; open descriptor file and read some weird vriables
;;


  IF NOT keyword_set(filepath) THEN filepath = '../mcm4-b/data/'
  DescFile = filepath+'model1/'+projname+'.000'
  DescFile2 = filepath+'model1/'+projname+'.001'
  DataFile = filepath+'result/'+projname
  c1 = ''
  plcoxd  = ''
  lux=2.99792458d+8  ;lux velocity in m/s
  
  openr, Unit, DescFile, /get_lun
  readf, Unit, d1               ; ndim 

  readf, Unit, d1               ; TSTAR
  readf, Unit, d2               ; RSTAR
  readf, Unit, d3               ; ndu
  readf, Unit, d4               ; sizexp

  readf, Unit, MAXBIN   & & print, '  <> MAXBIN                : ', MAXBIN
  readf, Unit, MAXOBS   & & print, '  <> MAXOBS                : ', MAXOBS
  readf, Unit, d1               ; MAXANG
  readf, Unit, d2               ; MAXNR
  readf, Unit, d3               ; nlam
  readf, Unit, nlam_pl  & & print, '  <> Number of wavelengths : ', nlam_pl
  readf, Unit, d5               ; ntho
  readf, Unit, d6               ; npho

  readf, Unit, d1               ; mxtem
  readf, Unit, d2               ; dtem
  
  readf, Unit, d1               ; concept
  readf, Unit, d2               ; fzeta
  readf, Unit, d3               ; ncutest
  readf, Unit, d4               ; fncutest
  readf, Unit, d5               ; UNIT
  readf, Unit, d6               ; hbas2
  readf, Unit, zoom1

  readf, Unit, d1               ; IMIN
  readf, Unit, d1               ; deltau
  readf, Unit, d1               ; ldiff
  readf, Unit, d1               ; xGOSTEPmax
  readf, Unit, d1               ; xGOSTEPmin
  
  readf, Unit, d1               ; RSUB
  readf, Unit, d1               ; sf
  readf, Unit, d1               ; opang
  

  readf, Unit, c1               ; dopwsave

  for i1=1, 20 do begin
      readf, Unit, d1           ; addpar(i1)
  endfor
  
  for i1=1, 10 do begin
      readf, Unit, d1           ; modpar(i1)
  endfor

  readf, Unit, d1               ; dimx(1)
  readf, Unit, d1               ; dimx(2)
  readf, Unit, d1               ; dimx(3)

  readf, Unit, c1               ; plco2d
  readf, Unit, c1               ; plco3d

  for i1=1, 3 do begin
      readf, Unit, d1           ;  MAXNRx(i1)
  endfor

  readf, Unit, d1               ; mxtaure
  readf, Unit, d1               ; npnort
  readf, Unit, d1               ; shppar
  readf, Unit, d1               ; nalpha
  readf, Unit, d1               ; nphi
  readf, Unit, d1               ; nrndpt
  readf, Unit, d1               ; zoomspek
  readf, Unit, plcoxd           ; plcoxd

  plcoxd = strcompress(plcoxd)   
  close, Unit
  
  ;; do something to plcoxd...
  
  f_plcoxd = 0
  if (MAXBIN*MAXOBS eq 0) then begin
      if (strmid(plcoxd, 1, 1) eq 'T') then begin
          f_plcoxd = 1
          print, '> plcoxd was activated (nversal plane concept)'
          read, 'Subproject (5 characters) : ', subpro
          MAXOBS = 1
          openr, 1, path_res + pronam(0) + '.' + subpro + suff(0)
          readf, 1, MAXOBS
          readf, 1, MAXBIN
          print, 'MAXOBS : ', MAXOBS
          print, 'MAXBIN : ', MAXBIN
          close, 1
      endif else begin
          print, '<!> ERROR: no plane concept was activated during simulation'
          
      endelse
  endif

  ;; make the result arrays
  
  Iall = FLTARR(nlam_pl, MAXOBS, 2*MAXBIN+1, 2*MAXBIN+1)
  Qall = FLTARR(nlam_pl, MAXOBS, 2*MAXBIN+1, 2*MAXBIN+1)
  Uall = FLTARR(nlam_pl, MAXOBS, 2*MAXBIN+1, 2*MAXBIN+1)
  Vall = FLTARR(nlam_pl, MAXOBS, 2*MAXBIN+1, 2*MAXBIN+1)

  ;; and read the values

  suff = ['.00I', '.00Q', '.00U', '.00V']
  for i4=0, 3 do begin
      akpro =  DataFile+ suff(i4)
      print, '   loading data from file ', akpro
      openr, Unit, akpro, /get_lun
      if (f_plcoxd eq 1) then begin
          readf, Unit, d1       ; MAXOBS
          readf, Unit, d1       ; MAXBIN
      endif
      for ilam=1, nlam_pl do begin ; alle wellenlaengen
          for i1=0, MAXOBS-1 do begin ; alle beob.ebenen
              for i2=0, (2*MAXBIN) do begin ; alle x/y - bins
                  for i3=0, (2*MAXBIN) do begin
                      readf, Unit, hd1
                      if i4 eq 0 then Iall(ilam-1, i1, i2, i3) = Iall(ilam-1, i1, i2, i3) + hd1
                      if i4 eq 1 then Qall(ilam-1, i1, i2, i3) = Qall(ilam-1, i1, i2, i3) + hd1
                      if i4 eq 2 then Uall(ilam-1, i1, i2, i3) = Uall(ilam-1, i1, i2, i3) + hd1
                      if i4 eq 3 then Vall(ilam-1, i1, i2, i3) = Vall(ilam-1, i1, i2, i3) + hd1
                  endfor
              endfor
          endfor
      endfor
      readf, Unit, NormFaks
      ;print,'First NormFaks',NormFaks
      close, Unit
  ENDFOR
  
      IF NOT keyword_set(lambda) THEN BEGIN 
          print, 'Using default Wavelength of 20 micron!'
          lambda = 20d-6
          IF nlam_pl GT 1 THEN lambda = replicate(lambda, nlam_pl)
      ENDIF 

      
      alpha = 0.0               ; if no desired distance given,  take from angle alpha
      LineRead = 'xxxx'
      openr, Unit, DescFile2
      REPEAT BEGIN 
          readf, Unit, LineRead
          aPos = strpos(LineRead, 'alplan')
          IF aPos NE -1 THEN $ 
            reads, LineRead, alpha
      ENDREP UNTIL eof(Unit)
      IF alpha EQ 0.0 THEN print, 'No info on angle alpha found in '+DescFile2
      
      alphas = !radeg*alpha*3600.  ; alpha in arcsec
      IF NOT keyword_set(distance) THEN $
        distance=2*d6/alphas 
      print, 'Found distance to target (pc): ', distance
   
  print,'Normfaks before conversion',NormFaks
  print,'angle',alpha
  print,'lux',lux
  print,'lambda',lambda
  print,'distance',distance
  
  ; Conversion of Normfaks from (W/m) to mJy
  NormFaks =$
  NormFaks*(lambda^2/lux)/(distance*3.085678d+16)^2*1d29/(2*!Pi*(1-cos(alpha)))
  
 print, 'New Factor of normalization', NormFaks

  NewSize = 256

  ;NewIarr = fltarr(nlam_pl, 2*MAXBIN+1, 2*MAXBIN+1)
  NewIarr = fltarr(nlam_pl, NewSize, NewSize)
  FOR i1=0, nlam_pl-1 DO BEGIN 
      HelpArr = total(Iall[i1, *, *, *], 2)/MAXOBS
      TotFlux = total(HelpArr)
      NewIarr[i1, *, *] = congrid(reform(total(Iall[i1, *, *, *], 2)/MAXOBS), NewSize, NewSize, /inter, cubic=-0.5); average all observation planes
      NewIarr[i1, *, *] = NewIarr[i1, *, *]/total(NewIarr[i1, *, *])*TotFlux 
  ENDFOR 
  NewIarr = NewIarr*NormFaks[0]    ; normalize to mJy / pixel
  NewIarr = reform(NewIarr)
  IF (size(NewIarr))[0] GT 2 THEN NewIarr = reform(NewIarr[0, *, *])
  lambda = lambda[0]
  print, 'Total flux density from target at wavelength (mJy):', total(NewIarr), lambda
  PixSize = 2*d6/distance/(NewSize)
  print, 'Size of one pixel (arcsec):', PixSize
 
  return, NewIarr
END



    
