FUNCTION vs_errbselect, state
  COMMON vs_block
  ;;
  EC_LAB = ['None', 'Estimate', '1%', '2%', '5%', '10%']
  OldErrbState = state.ErrbSize
  ErrbBase = Widget_Base(title='VS Error Bars', /col)
  ErrbLabel = Widget_Label(ErrbBase, val='Show Errorbars?', font=vs_fonts[1])
  ErrbCheck = Widget_Droplist(ErrbBase, val=EC_LAB, $
                             uval='ErrbCheck', $
                             font=vs_fonts[1])
  ErrbList = Widget_Button(ErrbBase, $
                           val='Observation Time List', $
                           uval='ErrbList', $
                           font=vs_fonts[1])
  ErrbControl = Widget_Base(ErrbBase, /row)
  ErrbCancel = Widget_Button(ErrbControl, $
                             val='Cancel', $
                             uval='ErrbCancel', $
                             font=vs_fonts[1])
  ErrbOK = Widget_Button(ErrbControl, val='OK', $
                         uval='ErrbOK', $
                         font=vs_fonts[1])
  IF olderrbstate EQ 0 THEN BEGIN 
      Widget_Control, ErrbCheck, set_drop=0
      Widget_Control, ErrbList, sens=0
  ENDIF ELSE BEGIN
      CASE state.ErrbSize OF
          -1:Widget_Control, ErrbCheck, set_drop=1
          0.01:Widget_Control, ErrbCheck, set_drop=2
          0.02:Widget_Control, ErrbCheck, set_drop=3
          0.05:Widget_Control, ErrbCheck, set_drop=4
          0.1:Widget_Control, ErrbCheck, set_drop=5
      ENDCASE 
  ENDELSE 
  Widget_Control, ErrbBase, /realize
  ;;
  ;; start the event loop
  ;;
  Eflag = 0
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(ErrbBase)
      CASE Event.ID OF
          ErrbCancel:BEGIN
              Eflag = 1
              widget_control, ErrbBase, /Clear_Events, /Destroy
              return, OldErrbState
          END 
          ErrbOK:BEGIN
              Eflag = 1
              NewErrbState = widget_info(ErrbCheck, /droplist_select)
              CASE NewErrbState OF 
                  1: NewErrbState = -1
                  2: NewErrbState = 0.01
                  3: NewErrbState = 0.02
                  4: NewErrbState = 0.05
                  5: NewErrbState = 0.1     
                  ELSE:NewErrbState = 0
              ENDCASE 
              widget_control, ErrbBase, /Clear_Events, /Destroy
              return, NewErrbState
          END 
          ErrbCheck:BEGIN
              IF vs_debug THEN print, (Event.Index)
              IF Event.Index EQ 0 THEN  BEGIN
                   Widget_Control, ErrbList, sens=0
               ENDIF ELSE BEGIN
                   Widget_Control, Errblist, sens=1
               ENDELSE 
              Widget_Control, ErrbCheck, /Clear_Events
          END 
          ErrbList:BEGIN
              ObsTimes = vs_obsselect(*state.ObsTimes)
              IF total(ObsTimes) NE -99 THEN BEGIN 
                  *state.ObsTimes = ObsTimes > state.StartHR < state.EndHR
              ENDIF
          END 
          ELSE:
      ENDCASE 
  ENDWHILE 
  return, -1
  END 
              

