PRO vs_fileimp, caller
  COMMON vs_block
  IF NOT vs_debug THEN on_error, 2

; basic definitions
  lab_comment = 'Comment character:'
  lab_flux = 'Max flux density (mJy/Pix):'
  lab_file = 'Filename:'
  lab_fliph = 'Flip horizontally:'
  lab_flipv = 'Flip vertically:'
  lab_inpscale = 'Flux scaling:'
  lab_name = 'Name of intermediate fits-file:'
  lab_ncol = '# of columns:'
  lab_nrow = '# of rows:'
  lab_nskip = '# of fields to skip at beginning:'
  lab_rot = 'Rotation (counterclockwise):'
  lab_scale = 'Scale (mas/Pix):'
  lab_sel = 'Select...'
  lab_title = 'SimVLTI File Importer'
  lab_wl = 'Wavelength (mum):'
;
  lab_ok = 'Import'
  lab_pre = 'Preview'
  lab_can = 'Cancel'
  labs_flip = ['N', 'Y']
;
  rotlist = ['0', '90', '180', '270']
  scalelist = ['Lin', 'Log', 'Sqr']
;
  typelist = ['JPEG image', 'Gif image', 'TIF Image', 'RT Code Manske', $
              'RT Code Wolf', 'RT Code Nelson', 'ASCII']
;
  val_flux = 100
  val_name = 'import.fits'
  val_scale = 10
  val_inpscale = 0
  val_rotation = 0
  val_type = 0
  ;;
  WinSize = 256                 ; size of preview window
  NumPars = 13                  ; number of adjustable parameters
;;
;; build the GUI
;;
  ImpBase = Widget_Base(col=2, tit=lab_title)
  ImpTypeBase = Widget_Base(ImpBase, col=1)
  ImpTList = cw_bgroup(ImpTypeBase, typelist, $
                       font=vs_fonts[1], $
                       /excl, $
                       col=1, $
                       set_val=val_type)

  ImpPreWin = Widget_draw(ImpTypeBase, scr_x=WinSize, scr_y=WinSize, /align_bottom)
;;

  ImpPars = Widget_Base(ImpBase, col=1)
;
  ImpFNameBase = Widget_Base(ImpPars, col=3, /base_align_right)
  ImpFNameLab = Widget_Label(ImpFNameBase, val=lab_file, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpFName = Widget_Text(ImpFNameBase, /align_right, /editable)
  ImpFNameSel = Widget_Button(ImpFNameBase, val=lab_sel, font=vs_fonts[1], /align_right)
;
  ImpONameBase = Widget_Base(ImpPars, col=3, /base_align_right)
  ImpONameLab = Widget_Label(ImpONameBase, val=lab_name, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpOName = Widget_Text(ImpONameBase, /align_right, /editable)
  ImpONameSel = Widget_Button(ImpONameBase, val=lab_sel, font=vs_fonts[1], /align_right)
;
  ImpScaleBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpScaleLab = Widget_Label(ImpScaleBase, val=lab_scale, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpScale = Widget_Text(ImpScaleBase, /align_right, /editable)
;
  ImpMFluxBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpMFluxLab = Widget_Label(ImpMFluxBase, val=lab_flux, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpMFlux = Widget_Text(ImpMFluxBase, /align_right, /editable)
;
  ImpWLBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpWLLab = Widget_Label(ImpWLBase, val=lab_wl, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpWL = Widget_Text(ImpWLBase, /align_right, /editable)
;
  ImpFlipHBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpFlipHLab = Widget_Label(ImpFlipHBase, val=lab_fliph, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpFlipHCheck = Widget_Button(ImpFlipHBase, val=labs_flip[0])
;
  ImpFlipVBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpFlipVLab = Widget_Label(ImpFlipVBase, val=lab_flipv, font=vs_fonts[1], $
                             /align_right, scr_xsize=200)
  ImpFlipVCheck = Widget_Button(ImpFlipVBase, val=labs_flip[0])
;
  ImpRotBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpRotLab = Widget_Label(ImpRotBase, val=lab_rot, font=vs_fonts[1], $
                           /align_right, scr_xsize=200)
  ImpRot = cw_bgroup(ImpRotBase, rotlist, font=vs_fonts[1], $
                     /excl, /row, set_val=val_rotation)
;
  ImpIScaleBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpIScaleLab = Widget_Label(ImpIScaleBase, val=lab_inpscale, font=vs_fonts[1], $
                              /align_right, scr_xsize=200)
  ImpIScale = cw_bgroup(ImpIScaleBase, scalelist, font=vs_fonts[1], $
                        /excl, /row, set_val=val_inpscale)
;
  ImpColBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpColLab = Widget_Label(ImpColBase, val=lab_ncol, font=vs_fonts[1], $
                           /align_right, scr_xsize=200)
  ImpCol = Widget_Text(ImpColBase, /align_right, /edit)
;
  ImpRowBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpRowLab = Widget_Label(ImpRowBase, val=lab_nrow, font=vs_fonts[1], $
                           /align_right, scr_xsize=200)
  ImpRow = Widget_Text(ImpRowBase, /align_right, /edit)
;
  ImpCommBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpCommLab = Widget_Label(ImpCommBase, val=lab_comment, font=vs_fonts[1], $
                            /align_right, scr_xsize=200)
  ImpComm = Widget_Text(ImpCommBase, /align_right, /edit)
;
  ImpSkipBase = Widget_Base(ImpPars, col=2, /base_align_right)
  ImpSkipLab = Widget_Label(ImpSkipBase, val=lab_nskip, font=vs_fonts[1], $
                            /align_right, scr_xsize=200)
  ImpSkip = Widget_Text(ImpSkipBase, /align_right, /edit)


;
  ImpAction = Widget_Base(ImpPars, col=3)
  ImpOK = Widget_Button(ImpAction, val=lab_ok, font=vs_fonts[1])
  ImpPre = Widget_Button(ImpAction, val=lab_pre, font=vs_fonts[1])
  ImpCancel = Widget_Button(ImpAction, val=lab_can, font=vs_fonts[1])

  BaseVector = [ImpFNameBase, ImpONameBase, ImpScaleBase, ImpMFluxBase, $
                ImpWLBase, ImpFlipHBase, ImpFlipVBase, ImpRotBase, $
                ImpIScaleBase, ImpColBase, ImpRowBase, ImpCommBase, $
                ImpSkipBase]
  ActiveVectors = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0], $
                   [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0], $
                   [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0], $
                   [1, 1, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0], $
                   [1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0], $
                   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1], $
                   [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]]

  Widget_Control, ImpBase, /realize
  FOR jj=0, NumPars-1 DO $
    Widget_Control, BaseVector[jj], sens=ActiveVectors[jj, val_type]
  Eflag = 0
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(impBase)
      IF Event.ID EQ ImpPre OR Event.ID EQ ImpOK THEN BEGIN 
          ;;
          ;; read inputs
          ;;
          Widget_Control, ImpFName, get_val=FName
          FName = FName[0]
          Widget_Control, ImpScale, get_val=PixScale
          PixScale = float(PixScale[0])/1000.
          Widget_Control, ImpMFlux, get_val=MaxFlux
          MaxFlux = float(MaxFlux[0])
          Widget_Control, ImpWL, get_val=Lambda
          Lambda = float(Lambda[0])/1d6
          Widget_control, ImpFlipHCheck, get_val=FlipH
          FlipH = where(labs_flip EQ FlipH)
          Widget_control, ImpFlipVCheck, get_val=FlipV
          FlipV = where(labs_flip EQ FlipV)
          Widget_Control, ImpRot, get_val=RotNumber
          Widget_Control, ImpIScale, get_val=IScale
          Widget_Control, ImpCol, get_val=NCol
          NCol = fix(NCol)
          Widget_Control, ImpRow, get_val=NRow
          NRow = fix(NRow)
          Widget_Control, ImpComm, get_val=ComChar
          ComChar = ComChar[0]
          Widget_Control, ImpSkip, get_val=NSkip
          NSkip = fix(NSkip)
          Widget_Control, ImpTList, get_value=TypeIndex
          ;;
          ;; check some integrities
          ;;
          IF FName EQ '' THEN BEGIN 
              dummy = dialog_message('No Input file selected!', /error)
              GOTO, endloop
          ENDIF 
          IF (findfile(FName))[0] EQ '' THEN BEGIN 
              dummy = dialog_message('Input File '+FName+' does not exist!', /error)
              GOTO, endloop
          ENDIF 
          Image = -1
          CASE TypeIndex OF
              0: BEGIN
                  Readable = query_jpeg(Fname, dummy)
                  IF Readable THEN $
                    read_jpeg, FName, Image, dummy, /two, dither=0 $
                  ELSE $
                      vs_info, 'Not a valid JPEG-file: '+FName,4
              END 
              1:BEGIN
                  IF !version.release GE 5.4 THEN BEGIN 
                      dummy = dialog_message('Gif support only up to IDL version 5.3 - complain to RSI!', /error)
                  ENDIF ELSE BEGIN 
                      Readable = query_gif(FName)
                      IF Readable THEN $
                        read_gif, FName, Image $
                      ELSE $
                        vs_info, 'Not a valid Gif-file: '+FName, 4
                  ENDELSE 
              END 
              2:BEGIN 
                  Readable = query_tiff(Fname, dummy)
                  IF Readable THEN $
                    Image=read_tiff(FName) $
                  ELSE $
                    vs_info, 'Not a valid TIFF-file: '+FName, 4
              END 
              3:BEGIN
                  Fname = findfile(Fname) ; check if file exists
                  Fname = Fname[0]
                  IF Fname NE '' THEN BEGIN 
                      IF strmid(Fname, strlen(Fname)-3) EQ 'grp' THEN BEGIN 
                          MapName = strmid(Fname, rstrpos(Fname, 'ma'))
                          IF strmid(MapName, 2, 1) EQ 'l' THEN log = 1 ELSE log = 0 ; check if map is logarithmic
                          ;; now read it
                          mh_mapread, Fname, xsize, ysize, Image, Lambda, TotFlux
                      ENDIF 
                  ENDIF  
                                ; check if errors happened... ifimage
                                ; has changed,  assume not
                  IF total(Image) EQ -1 THEN BEGIN 
                      vs_info, 'Cannot read file: '+Fname, 4
                  ENDIF ELSE BEGIN 
                      IF log THEN BEGIN 
                          Image = 10^Image ; correct scaling
                          Image = Image/total(Image)*TotFlux
                      ENDIF 
                  ENDELSE 
              END 
              4:BEGIN
                  CASE !VERSION.OS_FAMILY OF 
                      'MacOS':PathSep = ':'
                      'Windows:':PathSep = '\'
                      ELSE:PathSep = '/'
                  ENDCASE 
                  PathSepPos = rstrpos(Fname, PathSep) > 0
                  SuffixPos = rstrpos(Fname, '.')
                  ProjName = strmid(Fname, PathSepPos+1, SuffixPos-PathSepPos-1)
                  ProjPath = strmid(Fname, 0, PathSepPos)
                  PathSepPos = rstrpos(ProjPath, PathSep)
                  ProjPath = strmid(ProjPath, 0, PathSepPos)+PathSep                 
                  Image = sw_mapread(ProjName, FilePath=ProjPath, lambda=lambda, PixSize=PixScale)
                  PicScale = PixScale*1d3
                  Widget_Control, ImpWL, set_val=string(lambda*1d6)
                  Widget_Control, ImpScale, set_val=string(PixScale)
                  Widget_Control, ImpMFlux, set_val=string(max(Image))
              END 
              5:BEGIN
                  Fname = findfile(Fname) ; check if file exists
                  Fname = Fname[0]
                  NRow = fix(Nrow[0])
                  NCol = fix(NCol [0])
                  Nskip = fix(Nskip[0])
                  IF Fname NE '' THEN BEGIN 
                      Image = ab_readmap(Fname, NRow, NCol, Nskip)
                  ENDIF  
                  IF total(Image) EQ -1 THEN $ 
                      vs_info, 'Cannot read file: '+Fname, 4
              END 
              6:BEGIN
                  Fname = findfile(Fname) ; check if file exists
                  Fname = Fname[0]
                  NRow = fix(Nrow[0])
                  NCol = fix(NCol [0])
                  Nskip = fix(Nskip[0])
                  IF Fname NE '' THEN BEGIN 
                      vs_readascii, Fname, Image, NRow, NCol, Nskip, comchar=ComChar, missing=0
                  ENDIF  
                  IF total(Image) EQ -1 THEN $ 
                      vs_info, 'Cannot read file: '+Fname, 4
              END 
              ELSE: dummy = dialog_message('Not yet implemented...', /error)
          ENDCASE 
          IF total(Image) NE -1 THEN BEGIN ; go ahead if no error
              ;;
              ;; now make the allowed adjustments...
              ;;
              sxhmake, Image, 1, Header ; make image header
              ;;
              IF PixScale EQ 0 THEN BEGIN 
                  vs_info, 'PixScale set to zero - assuming 10 mas/Pix!', 3
                  PixScale = 0.01
                  Widget_Control, ImpScale, set_val=string(1000*PixScale)
              ENDIF 
              sxaddpar, Header, 'PIXSIZE', PixScale
              IF Activevectors[3, Typeindex] THEN BEGIN ; Flux scaling allowed...
                  IF MaxFlux EQ 0 THEN BEGIN 
                      vs_info, 'Maximum Flux set to zero - assuming 100mJy/Pix!', 3
                      MaxFlux = 100
                      Widget_Control, ImpMFlux, set_val=string(100.0)
                  ENDIF 
                  Image = Image/max(Image)*Maxflux
              ENDIF 
              sxaddpar, Header, 'CALUNIT', 'mJy/Pix'
              ;;
              IF Activevectors[4, Typeindex] THEN BEGIN ; Lambda arbitrary...
                  IF Lambda EQ 0 THEN BEGIN 
                      vs_info, 'Wavelength set to zero - assuming 10mum', 3
                      Lambda = 1d-5
                      Widget_Control, ImpWL, set_val=string(Lambda)
                  ENDIF 
              ENDIF 
              sxaddpar, Header, 'LAMBDA1', Lambda/1d6
              ;;
              ISize = size(Image)
              IF FlipH[0] THEN $
                Image[findgen(ISIze[1]), *]=Image[Isize[1]-1-findgen(Isize[1]), *]
              IF FlipV[0] THEN $
                Image[*, findgen(ISIze[2])]=Image[*, Isize[2]-1-findgen(Isize[1])]
              IF RotNumber THEN $
                Image=rotate(Image, Rotnumber)
              IF IScale EQ 1 THEN $
                Image=10^Image $
                ELSE IF IScale EQ 2 THEN $
                Image=Image^2            
              ;;
              ;; O.K., now display or write...
              ;;
              IF Event.ID EQ ImpPre THEN BEGIN 
                  Factor = min([WinSize/float(Isize[1]), WinSize/float(Isize[2])])
                  loadct, 0
                  tvscl, alog(congrid(Image, Isize[1]*Factor, Isize[2]*Factor) > 1e-15)
              ENDIF ELSE BEGIN 
                  Widget_Control, ImpOName, get_val=OFName
                  OFName = OFname[0]
                  IF OFName EQ '' THEN BEGIN 
                      dummy = dialog_message('Cannot write to empty file name!')
                  ENDIF ELSE BEGIN 
                      writefits, OFName, Image, Header
                      IF N_Elements(caller) NE 0 THEN BEGIN 
                          widget_control, caller.FName, set_val=OFName
                          widget_control, caller.Apply, sens=1
                      ENDIF 
                      Eflag = 1
                  ENDELSE 
              ENDELSE              
          ENDIF 
      ENDIF ELSE BEGIN 
          CASE Event.ID OF
              ImpCancel:BEGIN
                  Eflag = 1
              END 
              ImpTList:BEGIN
                  Widget_Control, ImpTList, get_value=TypeIndex
                  FOR jj=0, NumPars-1 DO $ 
                    Widget_Control, BaseVector[jj], $
                    sens=ActiveVectors[jj, TypeIndex]
              END 
              ImpFName:
              ImpFNameSel:Widget_Control, ImpFName, set_value=dialog_pickfile()
              ImpOName:
              ImpONameSel:Widget_Control, ImpOName, set_value=dialog_pickfile()
              ImpScale:
              ImpMFlux:
              ImpWL:
              ImpFlipHCheck:BEGIN
                  Widget_Control, ImpFlipHCheck, get_value=CurrentFlip
                  Widget_Control, ImpFlipHCheck, set_value=labs_flip[CurrentFlip EQ 'N']
              END 
              ImpFlipVCheck:BEGIN
                  Widget_Control, ImpFlipVCheck, get_value=CurrentFlip
                  Widget_Control, ImpFlipVCheck, set_value=labs_flip[CurrentFlip EQ 'N']
              END 
              ImpRot:
              ImpIScale:
              ImpCol:
              ImpRow:
              ImpSkip:
          ENDCASE 
      ENDELSE 
      endloop:
  ENDWHILE 
  Widget_Control, ImpBase, /Clear_Events, /Destroy
END 
