;; (c) 1999 M. Feldt <mfeldt@mpia-hd.mpg.de>
PRO vs_midiFVplot, state
  COMMON vs_block
  IF NOT vs_debug THEN on_error, 2
  ;;
  ;; get parameters
  ;;
  SelFrame = state.SelFrame     ;(Widget_Info(vs_midilist_id, /list_select))[0]
  IF vs_debug THEN print, 'Selected frame: ', SelFrame
  BaselineSelect = where(*state.BaseSelect EQ 1, NumBSelect)
  IF NumBselect EQ 0 THEN BEGIN
      vs_info, 'No Baselines Selected!', 4
      return
  ENDIF 
  VecSize = n_elements((*state.result).HFV[0, *, 0, 0])
  PlotVec = findgen(VecSize)
  MinX = min((*state.result).HFV[BaseLineSelect, PlotVec, 1, SelFrame], max=MaxX)
  MinY = min((*state.result).HFV[BaseLineSelect, PlotVec, 2, SelFrame], max=MaxY)
  ;;
  ;; Start plotting
  ;;
  ;; plot the first baseline
  PS = (!D.Name eq 'PS')
  
  IF (((*state.result).UseTrack)[state.SelFrame] EQ 1) AND (1-PS) THEN $
    tit='EXTERNAL FRINGE TRACKING NEEDED!!' $
  ELSE $
    tit=''
  plot, (*state.result).HFV[BaseLineSelect[0], PlotVec, 1, SelFrame], $
    (*state.result).HFV[BaseLineSelect[0], PlotVec, 2, SelFrame], $
    title=tit, $
    xtitle='Spatial Frequency (arcsec!E-1!N)', $
    ytitle='Visibility', $
    xrange=[minX, MaxX], $
    yrange=[0, MaxY*1.1], $
    color=255*(1-PS), $
    thick=1+3*PS, $
    xthick=1+3*PS, $
    Ythick=1+3*PS, $
    charthick=1+3*PS, $
    font=-1+PS, $
    nodata=PS
  ;; rest of baselines
  FOR i=0, NumBSelect-1 DO BEGIN 
      oplot, (*state.result).HFV[BaseLineSelect[i], PlotVec, 1, SelFrame], $
        (*state.result).HFV[BaseLineSelect[i], PlotVec, 2, SelFrame], $
        color=(*state.BaseLine)[2, BaseLineSelect[i]]
      IF state.ErrbSize NE 0 THEN BEGIN
          ;; if errorbars are whished,  plot some...
          PlotColor = !P.Color
          !p.Color = (*state.BaseLine)[2, BaseLineSelect[i]]
          ;;
          ;; first find the indexes closest to the wished ObsTimes
          ;; vector
          ;;
          N_ObsTimes = N_Elements(*state.ObsTimes)
          PosVec = intarr(N_ObsTimes) ; vector to hold ObsTime corresponding indexes
          FOR ObsI=0, N_ObsTimes-1 DO BEGIN 
              DiffVec = abs((*state.result).HFV[BaseLineSelect[i], *, 0, SelFrame] - (*state.ObsTimes)[ObsI])
              Dummy = min(DiffVec, wmin)
              PosVec[ObsI] = wmin
          ENDFOR 
          IF N_Elements(PosVec) EQ 1 THEN Posvec = replicate(PosVec, 2)
        
          IF state.ErrbSize LT 0 THEN BEGIN 
              errplot, reform((*state.result).HFV[BaseLineSelect[i], PosVec, 1, SelFrame]), $
                reform((*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]-$
                       (*state.result).HFV[BaseLineSelect[i], PosVec, 3, SelFrame]/2.), $
                reform((*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]+$
                       (*state.result).HFV[BaseLineSelect[i], PosVec, 3, SelFrame]/2.)
              !P.Color = PlotColor
          ENDIF ELSE BEGIN
             errplot, reform((*state.result).HFV[BaseLineSelect[i], PosVec, 1, SelFrame]), $
                reform((*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]-$
                       (*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]/2.*state.ErrbSize), $
                reform((*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]+$
                       (*state.result).HFV[BaseLineSelect[i], PosVec, 2, SelFrame]/2.*state.ErrbSize)
              !P.Color = PlotColor
          ENDELSE 
      ENDIF 
  ENDFOR 
END 
