;; (c) 1999 M. Feldt <mfeldt@mpia-hd.mpg.de>
FUNCTION vs_MakeOlist, ObsTimes
NumOTimes = N_ELements(ObsTimes)
OTimesDescr = strarr(NumOTimes)
FOR i = 0, NumOTimes-1 DO BEGIN
    OTimesDescr[i] = string(ObsTimes[i])
ENDFOR
return, OTimesDescr
END 


FUNCTION vs_ObsSelect, obstimes
  COMMON vs_block

  OTimesDescr = strarr(6)
  
; Labels for widgets
  
  lab_del = 'Delete'
  lab_apply = 'OK'
  lab_dismiss = 'Cancel'
  lab_new = 'Add'
  lab_panel = 'ObsTimes Setup'
  lab_time = 'Time (hrs. of meridian)'
  
  ;; Make baseline editor widget

  ObsBASE = widget_base(title = lab_panel, /Col, /Base_Align_Center)
  ObsEDIT = widget_base(ObsBASE, /frame, col = 2)
  ObsLAB1 = widget_label(ObsEDIT, val = lab_time, font = vs_fonts[1])
  ObsTIM = widget_text(ObsEDIT, val = string(Obstimes[0]), font = vs_fonts[1], /Edit)
  ;;
  ObsCONTR = widget_base(ObsBASE, col = 4)
  ObsNEW = widget_button(ObsCONTR, val = lab_new, font = vs_fonts[1])
  ObsDEL = widget_button(ObsCONTR, val = lab_del, font = vs_fonts[1])
  ObsAPPLY = widget_button(ObsCONTR, val = lab_apply, font = vs_fonts[1])
  ObsDISMISS = widget_button(ObsCONTR, val = lab_dismiss, font = vs_fonts[1])
  ObsLIST = widget_list(ObsBASE, val = '', $
                        xsize = 20, $
                        ysize = 30, $
                        font = vs_fonts[2])

; Initialize the GUI
  widget_control, ObsEDIT, sens = 0
  widget_control, ObsLIST, set_val = vs_MakeOlist(ObsTimes)
  widget_control, ObsDEL, sens = 0
  widget_control, ObsNEW, sens = 0
  widget_control, ObsAPPLY, sens = 0
  widget_control, ObsBASE, /realize
;;
;; event handling loop
;;
  Eflag = 0
  WHILE Eflag EQ 0 DO BEGIN
      Event = Widget_Event(ObsBase)
      CASE 1 OF 
          Event.ID EQ ObsApply:BEGIN 
              Widget_Control, ObsBase, /Clear_Events, /Destroy
              return, ObsTimes
          END
          Event.ID EQ ObsDISMISS:BEGIN
              Widget_Control, ObsBase, /Clear_Events, /Destroy
              return, -99
          END
          Event.ID EQ ObsList: BEGIN ;New item selected
              ListIndex = Event.INDEX ;update index
              CurrentObsTime = ObsTimes ;extract baseline array
              widget_control, ObsDEL, sens = 1 ;make delete button sensitive
              widget_control, ObsEDIT, sens = 1 ; and also the edit functions
              widget_control, ObsNEW, sens = 1 ;enable copying 
                                ;now update the edit controls
              widget_control, ObsTIM, set_val = string(CurrentObsTime[ListIndex])
          END
          Event.ID EQ ObsDEL:BEGIN
              NumOTimes = N_Elements(ObsTimes)
                                ;delete the selected element from the list if possible
              IF NumOTimes EQ 1 THEN BEGIN
                  dummy = dialog_message('ERROR: Last ObsTime cannot be deleted!', $
                                         /error)
              ENDIF ELSE BEGIN
                  
                                ;remove selected element
                  CurrentObsTime = ObsTimes
                  IF ListIndex EQ 0 THEN $
                    ObsTimes = CurrentObsTime[1:NumOTimes-1] $
                  ELSE IF ListIndex EQ NumOTimes-1 THEN $
                    ObsTimes = CurrentObsTime[0:NumOTimes-2] $
                  ELSE $
                    ObsTimes = CurrentObsTime[[findgen(ListIndex), $
                                               findgen(NumOTimes-$
                                                       ListIndex-1) + $
                                               ListIndex+1]]
                                ;reduce counter of baselines
                  NumOTimes = NumOTimes-1
                  CurrentObsTime = ObsTimes
                                ;set new listindex
                  ListIndex = (ListIndex-1) > 0
                                ;re-arrange controls
                  widget_control, ObsTim, set_val = string(CurrentObsTime[ListIndex])
                  widget_control, ObsList, set_val = vs_MakeOlist(ObsTimes)
                  widget_control, ObsList, set_list_sel = ListIndex
                  widget_control, ObsApply, sens = 1
              ENDELSE
          END
          Event.ID EQ ObsNew:BEGIN
              NumOTimes = N_Elements(ObsTimes)+1
              CurrentObsTime = ObsTimes
              ObsTimes = [[CurrentObsTime], $
                          CurrentObsTime[ListIndex]]
              ;; add selected element at the end
              ListIndex = NumOTimes-1 ;select new element
              ;; update list widget
              CurrentObsTime = ObsTimes
              widget_control, ObsList, set_val =  vs_MakeOlist(ObsTimes)
              widget_control, ObsList, set_list_sel = NumOTimes-1
              ;; re-arrange controls
              widget_control, ObsTim, set_val = string(CurrentObsTime[ListIndex])
              widget_control, ObsApply, sens = 1
          END
          Event.ID EQ ObsTim:BEGIN
              widget_control, ObsTim, get_value = NTim ;extract new telescope one
              ObsTimes[ListIndex] = float(Ntim) ;change corresponding value
              widget_control, ObsList, set_val = vs_MakeOlist(ObsTimes)
              widget_control, ObsList, set_list_sel = ListIndex ;re-set selected
              widget_control, ObsApply, sens = 1
          END
      ENDCASE 
  ENDWHILE 
  Widget_Control, ObsBase, /Clear_Events, /Destroy
  
END
